﻿using System;
using System.Collections.ObjectModel;
using System.Drawing;
using System.Web.Script.Serialization;
using System.Collections.ObjectModel;
using System.Web.UI;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WebEdition;
using System.Collections.Generic;
using System.Text;


namespace LineSample
{


    public partial class _Default : System.Web.UI.Page, ICallbackEventHandler
    {
        string callbackResult = string.Empty;

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                Map1.BackColor = Color.CadetBlue;
                //Map1.CurrentExtent = new RectangleShape(-180, 90, 180, -90);
                Map1.MapUnit = GeographyUnit.Meter;

                ManagedProj4Projection proj4 = new ManagedProj4Projection();
                proj4.InternalProjectionParameters = ManagedProj4Projection.GetEpsgParametersString(4326);
                proj4.ExternalProjectionParameters = ManagedProj4Projection.GetGoogleMapParametersString();

                proj4.Open();
                Map1.CurrentExtent = proj4.ConvertToExternalProjection(new RectangleShape(-180, 90, 180, -90));
                proj4.Close();

                Map1.MapTools.ScaleLine.Enabled = true;
                //Map1.MapTools.MiniMap.Enabled = true;
                //Map1.MapTools.PanZoom.Enabled = true;
                Map1.MapTools.PanZoomBar.Enabled = true;
                

                //Map1.MapTools.Logo.ImageUri = new Uri(FormUtils._sLogoIconFile, UriKind.RelativeOrAbsolute);
                Map1.MapTools.OverlaySwitcher.Enabled = true;
                Map1.MapTools.OverlaySwitcher.BackgroundColor = GeoColor.StandardColors.DarkSlateGray;
                Map1.MapTools.OverlaySwitcher.BaseOverlayTitle = "Base Overlay";

                InMemoryFeatureLayer ptLayer = new InMemoryFeatureLayer();

                InMemoryFeatureLayer lnLayer = new InMemoryFeatureLayer();


                PointShape ptShape = new PointShape(-80, 50);
                ptShape.Id = "001";
                PointShape ptShape2 = new PointShape(-40, 20);
                ptShape2.Id = "002";
                PointShape ptShape3 = new PointShape(-10, 70);
                ptShape3.Id = "003";
                PointShape ptShape4 = new PointShape(20, 10);
                ptShape4.Id = "004";

                List<Vertex> LVertices = new List<Vertex>();
                LVertices.Add(new Vertex(ptShape.X, ptShape.Y));
                LVertices.Add(new Vertex(ptShape2.X, ptShape2.Y));

                List<Vertex> LVertices2 = new List<Vertex>();
                LVertices2.Add(new Vertex(ptShape2.X, ptShape2.Y));
                LVertices2.Add(new Vertex(ptShape3.X, ptShape3.Y));

                LineShape line1 = new LineShape(LVertices);
                LineShape line2 = new LineShape(LVertices2);

                Feature feat1 = new Feature(ptShape);   
                Feature feat2 = new Feature(ptShape2);                
                Feature feat3 = new Feature(ptShape3);                
                Feature feat4 = new Feature(ptShape4);

                Feature lnFeat1 = new Feature(line1);
                Feature lnFeat2 = new Feature(line2);  

                ptLayer.InternalFeatures.Add(feat1);
                ptLayer.InternalFeatures.Add(feat2);
                ptLayer.InternalFeatures.Add(feat3);
                ptLayer.InternalFeatures.Add(feat4);

                lnLayer.InternalFeatures.Add(lnFeat1);
                lnLayer.InternalFeatures.Add(lnFeat2);

                ptLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = PointStyles.Capital1;
                ptLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

                ptLayer.FeatureSource.Projection = proj4;

                lnLayer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.Highway2;
                lnLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

                lnLayer.FeatureSource.Projection = proj4;

                LayerOverlay ptOverlay = new LayerOverlay("PointsOvl");
                ptOverlay.IsBaseOverlay = false;
                ptOverlay.Layers.Add(ptLayer);

                LayerOverlay lnOverlay = new LayerOverlay("LinesOvl");
                lnOverlay.IsBaseOverlay = false;
                lnOverlay.Layers.Add(lnLayer);

                Map1.CustomOverlays.Add(ptOverlay);
                Map1.CustomOverlays.Add(lnOverlay);
            }
        }

        #region ICallbackEventHandler Members

        public string GetCallbackResult()
        {
            return callbackResult;
        }

        public void RaiseCallbackEvent(string eventArgument)
        {

         
            //JavaScriptSerializer serializer = new JavaScriptSerializer();
            //if (eventArgument.StartsWith("LonLat"))
            //{
            //    string[] argumentArray = eventArgument.Split(new string[] { ":", "," }, StringSplitOptions.RemoveEmptyEntries);
            //    PointShape point = new PointShape(Convert.ToDouble(argumentArray[1]), Convert.ToDouble(argumentArray[2]));
                
            //    LayerOverlay overlay = (LayerOverlay)Map1.CustomOverlays["InMemoryLayer"];
            //    InMemoryFeatureLayer layer = (InMemoryFeatureLayer)overlay.Layers[0];
            //    layer.Open();
            //    Collection<Feature> features = layer.QueryTools.GetFeaturesNearestTo(point, Map1.MapUnit, 1, ReturningColumnsType.AllColumns);
            //    if (features.Count > 0)
            //    {
                   
            //    }
            //}
        }

        #endregion
    }
}
